.model tiny
.code

org 100h


loader:
  mov ax,201h
  mov bx,offset buf
  mov cx,1
  mov dx,80h
  int 13h                       ; load za oldboot (#1)

  mov ax,301h
  mov bx,offset buf
  mov cx,2
  mov dx,80h
  int 13h                       ; write za oldboot (#2)

  mov si,offset buf+1BEh
  mov di,offset P_TABLE
  mov cx,40h
  rep movsb                     ; Sauver partition table !

  mov ax,301h
  mov bx,offset boot
  mov cx,1
  mov dx,80h
  int 13h
  mov ax,4C00h
  int 21h

buf:

;*** BOOT ***

org 7C00h

boot:
  cli
  xor ax,ax
  mov ds,ax
  mov es,ax
  mov ss,ax
  mov sp,offset boot
  sti

  mov si,offset S_ENTETE
  call write_text

Oldboot:
  cld
  mov si,7C00h
  mov di,offset final
  mov cx,512
  rep movsb
  mov ax,offset final
  add ax,offset input
  sub ax,offset boot
  push ax
  ret

INPUT:
  in al,60h
  cmp al,59
  jne not_f1
  mov cx,1
  mov dx,0
  jmp Loadold
not_f1:
  cmp al,60
  jne not_f2
  mov cx,1
  mov dx,1
  jmp Loadold
not_f2:
  cmp al,61
  jne not_f3
  mov cx,2
  mov dx,80h
  jmp Loadold
not_f3:
  cmp al,62
  jne INPUT
  mov cx,1
  mov dx,81h
LoadOld:
  mov bx,7C00h
  mov ax,201h
  int 13h
  mov ax,201h
  int 13h
  push 7C00h
  ret

write_text:
  lodsb
  or al,al
  je write_text_end
  mov ah,0eh
  int 10h
  jmp write_text
write_text_end:
  ret

S_ENTETE db '*** Royale Boot Manager ***',13,10
         db '  F1 : flp 1',13,10
         db '  F2 : flp 2',13,10
         db '  F3 : hdd 1',13,10
         db '  F4 : hdd 2',13,10
         db 13,10,0

org 7dbeh

P_TABLE db 40h dup (?)
        dw 0aa55h

final:

end loader
