main segment
     assume cs:main


  org 100h

debut:
  jmp installer

;*** int 21 = emulated DOS ***

int21:

i0: ; =terminate program=
  cmp ah,0
  jne i1
  add sp,6
retf

i1:

deb dw 0
i9: ; =write=
  cmp ah,9
  jne i0A
  push si
  mov si,dx
  mov cs:deb,si
i9_search_$:
  lodsb
  cmp al,'$'
  jne i9_search_$
  mov byte ptr ds:[si-1],0
  push si
  mov si,cs:deb
  mov ah,1
  int 66h
  pop si
  mov byte ptr ds:[si-1],'$'
  pop si
iret

i0A: ; =read=
  cmp ah,0Ah
  jne i0B
  push es di cx
  push ds
  pop es
  mov di,dx
  mov ah,2
  int 66h
  mov al,13
  stosb
  pop cx di es
iret

i0B:

i2A: ;=lire la date=

i4C:
  cmp ah,4Ch
  jne i4D
  add sp,6
retf

i4D:

not_implemented:
  push ds si dx
  push cs
  pop ds
  xor dh,dh
  mov dl,ah
  mov si,offset S_fonction
  mov ah,1
  int 66h
  mov ah,4
  int 66h
  mov si,offset S_not_implemented
  mov ah,1
  int 66h
  pop dx si ds
iret

S_fonction db 'Erreur DOSemu : INT 21h / Fonction ',0
S_not_implemented db ' non implmente !',13,10,0

int21_end:

;*****************************************************************************

installer:
  mov si,offset S_VERSION
  mov ah,1
  int 66h

;*** MOVE INT21 in MEMORY ***
  mov cx,offset int21_end-offset debut
  mov ah,60
  int 66h
  mov si,offset debut
  xor di,di
  rep movsb

;*** SET INT21 TABLE ***
  push es
  xor ax,ax
  mov es,ax
  mov di,21h*4
  mov ax,offset int21
  stosw
  pop ax                ; segment of interrupt-16 to simulate 100h offset !
  sub ax,16
  stosw

;*** OK ***
  mov si,offset S_Int21_OK
  mov ah,1
  int 66h


  retf

S_VERSION db 'DOSemu [Version 0]',13,10,0
S_Int21_OK db 'Interruption 21h installe.',13,10,0


main ends

end debut
